
%global pkg_name MonadCatchIO-transformers
%global pkgver %{pkg_name}-%{version}

Name:           ghc-%{pkg_name}
Version:        0.3.1.3
Release:    1%{?dist}
Summary:        Exception handling with IO monad transformers

License:        BSD-3-Clause
Url:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkgver}/%{pkgver}.tar.gz

BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-rpm-macros
BuildRequires:  ghc-base-devel
BuildRequires:  ghc-extensible-exceptions-devel
BuildRequires:  ghc-monads-tf-devel
BuildRequires:  ghc-transformers-devel
%if %{with ghc_prof}
BuildRequires:  ghc-base-prof
BuildRequires:  ghc-extensible-exceptions-prof
BuildRequires:  ghc-monads-tf-prof
BuildRequires:  ghc-transformers-prof
%endif

%description
Provides functions to throw and catch exceptions. Unlike the functions from
'Control.Exception', which work in 'IO', these work in any stack of monad
transformers (from the 'transformers' package) with 'IO' as the base monad.
You can extend this functionality to other monads, by creating an instance of
the 'MonadCatchIO' class. Warning: this library is deprecated. Use the
'exceptions' library instead, if possible.


%package devel
Summary:        Haskell %{pkg_name} library development files
Provides:       %{name}-static = %{version}-%{release}
Provides:       %{name}-static = %{version}-%{release}
%if %{defined ghc_version}
Requires:       ghc-compiler = %{ghc_version}
%endif
Requires:       %{name} = %{version}-%{release}

%description devel
This package provides the Haskell %{pkg_name} library
development files.


%if %{with haddock}
%package doc
Summary:        Haskell %{pkg_name} library documentation
BuildArch:      noarch
Requires:       ghc-filesystem

%description doc
This package provides the Haskell %{pkg_name} library
documentation.
%endif


%if %{with ghc_prof}
%package prof
Summary:        Haskell %{pkg_name} profiling library
Requires:       %{name}-devel = %{version}-%{release}
Supplements:    (%{name}-devel and ghc-prof)

%description prof
This package provides the Haskell %{pkg_name} profiling
library.
%endif


%prep
%setup -q -n %{pkgver}
cabal-tweak-dep-ver base '< 4.9' '< 5'
cabal-tweak-dep-ver transformers '< 0.5' '< 0.6'

sed -i 's/\r//' LICENSE


%build
%ghc_lib_build


%install
%ghc_lib_install


%files -f %{name}.files
%license LICENSE


%files devel -f %{name}-devel.files


%if %{with haddock}
%files doc -f %{name}-doc.files
%license LICENSE
%endif


%if %{with ghc_prof}
%files prof -f %{name}-prof.files
%endif


%changelog
* Thu Aug 08 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.3.1.3-1
- initial build
